| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Static Public Member Functions | Private Attributes | List of all members
IgHookTrace Class Reference

`#include <src/component/IgHook_IgHookTrace.h>`

Collaboration diagram for IgHookTrace:
[legend]

## Classes
struct | Counter
| Nearly dummy object type to identify a counter. More...
class | CounterValue
| Value for a counter chained from a trace. More...

## Public Member Functions
void * | operator new (size_t n, IgHookTraceAlloc *alloc=0)
| IgHookTrace (IgHookTrace *parent=0, void *address=0)
IgHookTrace * | parent (void)
IgHookTrace * | next (void)
void * | address (void)
bool | symbol (const char *&sym, const char *&lib, int &offset, int &liboffset)
IgHookTrace * | children (void)
IgHookTrace * | child (void *address)
CounterValue * | counters (void)
CounterValue * | counter (Counter *id)
void | merge (IgHookTrace *other)

## Static Public Member Functions
static int | stacktrace (void **addresses, int nmax)
static void * | tosymbol (void *address)
static bool | symbol (void *address, const char *&sym, const char *&lib, int &offset, int &liboffset)

## Private Attributes
IgHookTraceAlloc * | m_alloc
IgHookTrace * | m_parent
IgHookTrace * | m_next
IgHookTrace * | m_children
void * | m_address
CounterValue * | m_counters

## Detailed Description

Definition at line 28 of file IgHook_IgHookTrace.h.

## Constructor & Destructor Documentation

IgHookTrace::IgHookTrace | ( | IgHookTrace * | parent = `0`,
|  | void * | address = `0`
| ) |  |

Definition at line 205 of file IgHook_IgHookTrace.cpp.

206 : m_alloc (parent ? parent->m_alloc : new IgHookTraceAlloc),
207 m_parent (parent),
208 m_next (parent ? parent->m_children : 0),
209 m_children (0),
210 m_address (address),
211 m_counters (0)
212 { if (m_parent) m_parent->m_children = this; }
IgHookTrace::m_children
IgHookTrace * m_children
Definition: IgHook_IgHookTrace.h:99
IgHookTrace::m_parent
IgHookTrace * m_parent
Definition: IgHook_IgHookTrace.h:97
IgHookTrace::address
void * address(void)
Definition: IgHook_IgHookTrace.cpp:223
IgHookTrace::m_next
IgHookTrace * m_next
Definition: IgHook_IgHookTrace.h:98
IgHookTrace::m_counters
CounterValue * m_counters
Definition: IgHook_IgHookTrace.h:101
IgHookTrace::m_alloc
IgHookTraceAlloc * m_alloc
Definition: IgHook_IgHookTrace.h:96
IgHookTrace::m_address
void * m_address
Definition: IgHook_IgHookTrace.h:100
IgHookTraceAlloc
Definition: IgHook_IgHookTrace.h:16

## Member Function Documentation

void * IgHookTrace::address | ( | void |  | ) |

Definition at line 223 of file IgHook_IgHookTrace.cpp.

224 { return m_address; }
IgHookTrace::m_address
void * m_address
Definition: IgHook_IgHookTrace.h:100

IgHookTrace* IgHookTrace::child | ( | void * | address | ) |

IgHookTrace* IgHookTrace::children | ( | void |  | ) |

CounterValue* IgHookTrace::counter | ( | Counter * | id | ) |

CounterValue* IgHookTrace::counters | ( | void |  | ) |

void IgHookTrace::merge | ( | IgHookTrace * | other | ) |

IgHookTrace * IgHookTrace::next | ( | void |  | ) |

Definition at line 219 of file IgHook_IgHookTrace.cpp.

220 { return m_next; }
IgHookTrace::m_next
IgHookTrace * m_next
Definition: IgHook_IgHookTrace.h:98

void * IgHookTrace::operator new | ( | size_t | n,
|  | IgHookTraceAlloc * | alloc = `0`
| ) |  |

Definition at line 202 of file IgHook_IgHookTrace.cpp.

203 { return alloc ? alloc->allocate (n) : ::operator new (n); }
GaudiPluginService.cpluginsvc.n
n
Definition: cpluginsvc.py:217
IgHookTraceAlloc::allocate
void * allocate(size_t bytes)
Definition: IgHook_IgHookTrace.cpp:105

IgHookTrace * IgHookTrace::parent | ( | void |  | ) |

Definition at line 215 of file IgHook_IgHookTrace.cpp.

216 { return m_parent; }
IgHookTrace::m_parent
IgHookTrace * m_parent
Definition: IgHook_IgHookTrace.h:97

static int IgHookTrace::stacktrace | ( | void ** | addresses,
|  | int | nmax
| ) |  |
| static

bool IgHookTrace::symbol | ( | void * | address,
|  | const char *& | sym,
|  | const char *& | lib,
|  | int & | offset,
|  | int & | liboffset
| ) |  |
| static

Definition at line 227 of file IgHook_IgHookTrace.cpp.

232 {
233 sym = lib = 0;
234 offset = 0;
235 liboffset = (unsigned long) address;
236
237 Dl_info info;
238 if (dladdr (address, &info))
239 {
240 if (info.dli_fname && info.dli_fname [0])
241 lib = info.dli_fname;
242
243 if (info.dli_fbase)
244 liboffset = (unsigned long) address - (unsigned long) info.dli_fbase;
245
246 if (info.dli_saddr)
247 offset = (unsigned long) address - (unsigned long) info.dli_saddr;
248
249 if (info.dli_sname && info.dli_sname [0])
250 sym = info.dli_sname;
251
252 return true;
253 }
254
255 return false;
256 }
IgHookTrace::address
void * address(void)
Definition: IgHook_IgHookTrace.cpp:223

bool IgHookTrace::symbol | ( | const char *& | sym,
|  | const char *& | lib,
|  | int & | offset,
|  | int & | liboffset
| ) |  |

Definition at line 259 of file IgHook_IgHookTrace.cpp.

260 { return symbol (m_address, sym, lib, offset, liboffset); }
IgHookTrace::symbol
static bool symbol(void *address, const char *&sym, const char *&lib, int &offset, int &liboffset)
Definition: IgHook_IgHookTrace.cpp:227
IgHookTrace::m_address
void * m_address
Definition: IgHook_IgHookTrace.h:100

void * IgHookTrace::tosymbol | ( | void * | address | ) |
| static

Definition at line 263 of file IgHook_IgHookTrace.cpp.

264 {
265 Dl_info info;
266 return (dladdr (address, &info)
267 && info.dli_fname
268 && info.dli_fname [0]
269 && info.dli_saddr)
270 ? info.dli_saddr : address;
271 }
IgHookTrace::address
void * address(void)
Definition: IgHook_IgHookTrace.cpp:223

## Member Data Documentation

void* IgHookTrace::m_address
| private

Definition at line 100 of file IgHook_IgHookTrace.h.

IgHookTraceAlloc* IgHookTrace::m_alloc
| private

Definition at line 96 of file IgHook_IgHookTrace.h.

IgHookTrace* IgHookTrace::m_children
| private

Definition at line 99 of file IgHook_IgHookTrace.h.

CounterValue* IgHookTrace::m_counters
| private

Definition at line 101 of file IgHook_IgHookTrace.h.

IgHookTrace* IgHookTrace::m_next
| private

Definition at line 98 of file IgHook_IgHookTrace.h.

IgHookTrace* IgHookTrace::m_parent
| private

Definition at line 97 of file IgHook_IgHookTrace.h.

The documentation for this class was generated from the following files:

- GaudiProfiling/src/component/IgHook_IgHookTrace.h
- GaudiProfiling/src/component/IgHook_IgHookTrace.cpp